cr = 
[[



  Script Version: 1.0
  Copyright 2014-2015 by Alex2009(www.Alex2009.de)

  Dieses Werk bzw. Inhalt von Alex2009 ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Keine Bearbeitung 3.0 Unported Lizenz. 
  Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-nc-nd/3.0/deed.de
  ueber diese Lizenz hinausgehende Erlaubnisse koennen Sie unter http://www.Alex2009.de erhalten.
  
  
  
]]

Mobile_Ampel = {};

function Mobile_Ampel.prerequisitesPresent(specializations)
    return true
end;

function Mobile_Ampel:load(xmlFile)
    self.triggerCallback = Mobile_Ampel.triggerCallback
    self.setAmpelLightState = SpecializationUtil.callSpecializationsFunction("setAmpelLightState");
    self.setAmpelToggleState = SpecializationUtil.callSpecializationsFunction("setAmpelToggleState");
    self.setAmpelFlashState = SpecializationUtil.callSpecializationsFunction("setAmpelFlashState");
	self.Ampel = {};
	self.Ampel.index = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#index"));
    self.Ampel.Trigger = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Trigger"));
    addTrigger(self.Ampel.Trigger,"triggerCallback",self);
	self.Ampel.rot = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Rot"));
	self.Ampel.orange = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Orange"));
	self.Ampel.gruen = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Ampel#Gruen"));
    g_currentMission.nodeToVehicle[self.Ampel.index] = {};
	self.Ampelstate = false;
	self.ALightstate = 1;
    self.atime = 0;
    self.trafficIndex = 0;
    self.isInOutDoorTrigger = false;
    self.isAmpelToggled = false;
end;

function Mobile_Ampel:delete()
end;

function Mobile_Ampel:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Mobile_Ampel:keyEvent(unicode, sym, modifier, isDown)
end;

function Mobile_Ampel:update(dt)
    if self:getIsActiveForInput() or self.isInOutDoorTrigger then
        if InputBinding.hasEvent(InputBinding.Ampel_AnAus) then
		    if not self.Ampelstate then
                self:setAmpelLightState(true,false,false);
                self.ALightstate = 1;
                self.atime = 0;
		    else
                self:setAmpelLightState(false,false,false);
		    end;
	    end;
        if self.Ampelstate then
            if not self.isAmpelFlashing then
                if InputBinding.hasEvent(InputBinding.Ampel_Toggle) then
                    self:setAmpelToggleState(not self.isAmpelToggled);
                end;
                if InputBinding.hasEvent(InputBinding.Ampel_PhaseC) then
                    if self.trafficIndex == 0 then
                        self.trafficIndex = 1;
                    else
                        self.trafficIndex = 0;
                    end;
                    MobileAmpelExtrasPhaseEvent.sendEvent(self, self.trafficIndex);
                end;
            end;
            if not self.isAmpelToggled then
                if InputBinding.hasEvent(InputBinding.Ampel_Blink) then
                    self:setAmpelFlashState(not self.isAmpelFlashing);
                end;
            end;
        end;
        if self.Ampelstate then
            g_currentMission:addHelpButtonText(g_i18n:getText("AmpelphaseInfo")..tostring(self.trafficIndex), InputBinding.Ampel_PhaseC);
            g_currentMission:addHelpButtonText(g_i18n:getText("AmpelOff"), InputBinding.Ampel_AnAus);
            if not self.isAmpelFlashing then
                if self.isAmpelToggled then
                    g_currentMission:addHelpButtonText(g_i18n:getText("AmpelToggleOff"), InputBinding.Ampel_Toggle);
                else
                    g_currentMission:addHelpButtonText(g_i18n:getText("AmpelToggleOn"), InputBinding.Ampel_Toggle);
                end;
            end;
            if not self.isAmpelToggled then
                if self.isAmpelFlashing then
                    g_currentMission:addHelpButtonText(g_i18n:getText("AmpelBlinkOff"), InputBinding.Ampel_Blink);
                else
                    g_currentMission:addHelpButtonText(g_i18n:getText("AmpelBlinkOn"), InputBinding.Ampel_Blink);
                end;
            end;
        else
            g_currentMission:addHelpButtonText(g_i18n:getText("AmpelOn"), InputBinding.Ampel_AnAus);
        end;
	end;
end;

function Mobile_Ampel:triggerCallback(triggerId,otherId,onEnter,onLeave,onStay)
    if onEnter or onLeave then
        if g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
            if onEnter then
                self.isInOutDoorTrigger = true;
            else
                self.isInOutDoorTrigger = false;
            end;
        end;
    end;
end;

local oldPlayerupdateTick = Player.updateTick;
Player.updateTick = function(self,dt)
    oldPlayerupdateTick(self,dt)
    if self.isServer then
        if g_currentMission.MobileTrafficLight == nil then
            g_currentMission.MobileTrafficLight = {};
            g_currentMission.MobileTrafficLight.state = {};
            g_currentMission.MobileTrafficLight.state[0] = 3;
            g_currentMission.MobileTrafficLight.state[1] = 1;
            g_currentMission.MobileTrafficLight.time = {};
            g_currentMission.MobileTrafficLight.time[0] = 0;
            g_currentMission.MobileTrafficLight.time[1] = 0;
        else
            g_currentMission.MobileTrafficLight.time[0] = g_currentMission.MobileTrafficLight.time[0] + dt;
            g_currentMission.MobileTrafficLight.time[1] = g_currentMission.MobileTrafficLight.time[1] + dt;
            if g_currentMission.MobileTrafficLight.time[0] > 51700 and g_currentMission.MobileTrafficLight.state[0] == 1 then
                g_currentMission.MobileTrafficLight.state[0] = 2;
                g_currentMission.MobileTrafficLight.time[0] = 0;
            elseif g_currentMission.MobileTrafficLight.time[0] > 1400 and g_currentMission.MobileTrafficLight.state[0] == 2 then
                g_currentMission.MobileTrafficLight.state[0] = 3;
                g_currentMission.MobileTrafficLight.time[0] = 0;
            elseif g_currentMission.MobileTrafficLight.time[0] > 20000 and g_currentMission.MobileTrafficLight.state[0] == 3 then
                g_currentMission.MobileTrafficLight.state[0] = 4;
                g_currentMission.MobileTrafficLight.time[0] = 0;
            elseif g_currentMission.MobileTrafficLight.time[0] > 1450 and g_currentMission.MobileTrafficLight.state[0] == 4 then
                g_currentMission.MobileTrafficLight.state[0] = 5;
                g_currentMission.MobileTrafficLight.time[0] = 0;
            elseif g_currentMission.MobileTrafficLight.time[0] > 8000 and g_currentMission.MobileTrafficLight.state[0] == 5 then
                g_currentMission.MobileTrafficLight.state[0] = 1;
                g_currentMission.MobileTrafficLight.time[0] = 0;
            end;
            if g_currentMission.MobileTrafficLight.time[1] > 51700 and g_currentMission.MobileTrafficLight.state[1] == 1 then
                g_currentMission.MobileTrafficLight.state[1] = 2;
                g_currentMission.MobileTrafficLight.time[1] = 0;
            elseif g_currentMission.MobileTrafficLight.time[1] > 1400 and g_currentMission.MobileTrafficLight.state[1] == 2 then
                g_currentMission.MobileTrafficLight.state[1] = 3;
                g_currentMission.MobileTrafficLight.time[1] = 0;
            elseif g_currentMission.MobileTrafficLight.time[1] > 20000 and g_currentMission.MobileTrafficLight.state[1] == 3 then
                g_currentMission.MobileTrafficLight.state[1] = 4;
                g_currentMission.MobileTrafficLight.time[1] = 0;
            elseif g_currentMission.MobileTrafficLight.time[1] > 1450 and g_currentMission.MobileTrafficLight.state[1] == 4 then
                g_currentMission.MobileTrafficLight.state[1] = 5;
                g_currentMission.MobileTrafficLight.time[1] = 0;
            elseif g_currentMission.MobileTrafficLight.time[1] > 8000 and g_currentMission.MobileTrafficLight.state[1] == 5 then
                g_currentMission.MobileTrafficLight.state[1] = 1;
                g_currentMission.MobileTrafficLight.time[1] = 0;
            end;
        end;
    end;
end;

function Mobile_Ampel:updateTick(dt)
    if (self.isServer or self.isAmpelFlashing) and self.Ampelstate then
        if not self.isAmpelToggled and not self.isAmpelFlashing then 
            if g_currentMission.MobileTrafficLight.state[self.trafficIndex] ~= self.ALightstate then
                if g_currentMission.MobileTrafficLight.state[self.trafficIndex] == 2 then
                    self:setAmpelLightState(true,true,false);
                    self.ALightstate = 1;
                elseif g_currentMission.MobileTrafficLight.state[self.trafficIndex] == 3 then
                    self:setAmpelLightState(false,false,true);
                    self.ALightstate = 2;
                elseif g_currentMission.MobileTrafficLight.state[self.trafficIndex] == 4 then
                    self:setAmpelLightState(false,true,false);
                    self.ALightstate = 3;
                elseif g_currentMission.MobileTrafficLight.state[self.trafficIndex] == 5 then
                    self:setAmpelLightState(true,false,false);
                    self.ALightstate = 4;
                elseif g_currentMission.MobileTrafficLight.state[self.trafficIndex] == 1 then
                    self:setAmpelLightState(true,false,false);
                    self.ALightstate = 5;
                end;
            end;
        elseif self.isAmpelFlashing then
            self.atime = self.atime + dt;
            if self.atime > 1000 and not getVisibility(self.Ampel.orange) then
                setVisibility(self.Ampel.gruen, false);
                setVisibility(self.Ampel.orange, true);
                setVisibility(self.Ampel.rot, false);
                self.atime = 0;
            elseif self.atime > 500 and getVisibility(self.Ampel.orange) then
                setVisibility(self.Ampel.gruen, false);
                setVisibility(self.Ampel.orange, false);
                setVisibility(self.Ampel.rot, false);
                self.atime = 0;
            end;
        end;
	end;
end;

function Mobile_Ampel:readStream(streamId, connection)
    local red = streamReadBool(streamId);
    local orange = streamReadBool(streamId);
    local green = streamReadBool(streamId);
    self:setAmpelLightState(red,orange,green,true);
    self.isAmpelToggled = streamReadBool(streamId);
    self.isAmpelFlashing = streamReadBool(streamId);
    self.Ampelstate = streamReadBool(streamId);
    self.trafficIndex = streamReadInt32(streamId);
end;
 
function Mobile_Ampel:writeStream(streamId, connection)
    streamWriteBool(streamId, self.Ampel.rot);
    streamWriteBool(streamId, self.Ampel.orange);
    streamWriteBool(streamId, self.Ampel.gruen);    
    streamWriteBool(streamId, self.isAmpelToggled);
    streamWriteBool(streamId, self.isAmpelFlashing);
    streamWriteBool(streamId, self.Ampelstate);
    streamWriteInt32(streamId, self.trafficIndex);      
end;

function Mobile_Ampel:setAmpelLightState(red,orange,green,noEventSend)
    setVisibility(self.Ampel.gruen, green);
    setVisibility(self.Ampel.orange, orange);
    setVisibility(self.Ampel.rot, red);
    local x, y, z = getTranslation(self.Ampel.index);
    if red then
        setTranslation(self.Ampel.index,-2.6,y,z);
    else
        setTranslation(self.Ampel.index,0,y,z);
    end;
    if not red and not orange and not green then
        setTranslation(self.Ampel.index,0,y,z);
        self.Ampelstate = false;
        self.ALightstate = 1;
        self.atime = 0;
    else
        self.Ampelstate = true;
    end;
    MobileAmpelExtrasEvent.sendEvent(self, red, orange, green, noEventSend);
end;

function Mobile_Ampel:setAmpelToggleState(state,noEventSend)
    self.isAmpelToggled = state;
    MobileAmpelExtrasToggleEvent.sendEvent(self, state, noEventSend);
end;

function Mobile_Ampel:setAmpelFlashState(state,noEventSend)
    self.isAmpelFlashing = state;
    setTranslation(self.Ampel.index,0,y,z);
    self.ALightstate = 1;
    self.atime = 0;
    if not state then
        self:setAmpelLightState(true,false,false);
    else
        self:setAmpelLightState(false,true,false);
    end;
    MobileAmpelExtrasFlashEvent.sendEvent(self, state, noEventSend);
end;
  
function Mobile_Ampel:draw()
end;

MobileAmpelExtrasEvent = {};
MobileAmpelExtrasEvent_mt = Class(MobileAmpelExtrasEvent, Event);

InitEventClass(MobileAmpelExtrasEvent, "MobileAmpelExtrasEvent");

function MobileAmpelExtrasEvent:emptyNew()
    local self = Event:new(MobileAmpelExtrasEvent_mt);
    self.className="MobileAmpelExtrasEvent";
    return self;
end;

function MobileAmpelExtrasEvent:new(object, red, orange, green)
    local self = MobileAmpelExtrasEvent:emptyNew()
	self.object = object;
    self.red = red;
    self.orange = orange;
    self.green = green;
	return self;
end;

function MobileAmpelExtrasEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
    self.red = streamReadBool(streamId);
    self.orange = streamReadBool(streamId);
    self.green = streamReadBool(streamId);
    self:run(connection);
end;

function MobileAmpelExtrasEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.red);
    streamWriteBool(streamId, self.orange);
    streamWriteBool(streamId, self.green);
end;

function MobileAmpelExtrasEvent:run(connection)
	self.object:setAmpelLightState(self.red, self.orange, self.green, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(MobileAmpelExtrasEvent:new(self.object, self.red, self.orange, self.green), nil, connection, self.object);
    end;	
end;

function MobileAmpelExtrasEvent.sendEvent(vehicle, red, orange, green, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MobileAmpelExtrasEvent:new(vehicle, red, orange, green), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MobileAmpelExtrasEvent:new(vehicle, red, orange, green));
		end;
	end;
end;

MobileAmpelExtrasToggleEvent = {};
MobileAmpelExtrasToggleEvent_mt = Class(MobileAmpelExtrasToggleEvent, Event);

InitEventClass(MobileAmpelExtrasToggleEvent, "MobileAmpelExtrasToggleEvent");

function MobileAmpelExtrasToggleEvent:emptyNew()
    local self = Event:new(MobileAmpelExtrasToggleEvent_mt);
    self.className="MobileAmpelExtrasToggleEvent";
    return self;
end;

function MobileAmpelExtrasToggleEvent:new(object, state)
    local self = MobileAmpelExtrasToggleEvent:emptyNew()
	self.object = object;
    self.state = state;
	return self;
end;

function MobileAmpelExtrasToggleEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
    self.state = streamReadBool(streamId);
    self:run(connection);
end;

function MobileAmpelExtrasToggleEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.state);
end;

function MobileAmpelExtrasToggleEvent:run(connection)
	self.object:setAmpelToggleState(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(MobileAmpelExtrasToggleEvent:new(self.object, self.state), nil, connection, self.object);
    end;	
end;

function MobileAmpelExtrasToggleEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MobileAmpelExtrasToggleEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MobileAmpelExtrasToggleEvent:new(vehicle, state));
		end;
	end;
end;

MobileAmpelExtrasFlashEvent = {};
MobileAmpelExtrasFlashEvent_mt = Class(MobileAmpelExtrasFlashEvent, Event);

InitEventClass(MobileAmpelExtrasFlashEvent, "MobileAmpelExtrasFlashEvent");

function MobileAmpelExtrasFlashEvent:emptyNew()
    local self = Event:new(MobileAmpelExtrasFlashEvent_mt);
    self.className="MobileAmpelExtrasFlashEvent";
    return self;
end;

function MobileAmpelExtrasFlashEvent:new(object, state)
    local self = MobileAmpelExtrasFlashEvent:emptyNew()
	self.object = object;
    self.state = state;
	return self;
end;

function MobileAmpelExtrasFlashEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
    self.state = streamReadBool(streamId);
    self:run(connection);
end;

function MobileAmpelExtrasFlashEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.state);
end;

function MobileAmpelExtrasFlashEvent:run(connection)
	self.object:setAmpelFlashState(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(MobileAmpelExtrasFlashEvent:new(self.object, self.state), nil, connection, self.object);
    end;	
end;

function MobileAmpelExtrasFlashEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MobileAmpelExtrasFlashEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MobileAmpelExtrasFlashEvent:new(vehicle, state));
		end;
	end;
end;

MobileAmpelExtrasPhaseEvent = {};
MobileAmpelExtrasPhaseEvent_mt = Class(MobileAmpelExtrasPhaseEvent, Event);

InitEventClass(MobileAmpelExtrasPhaseEvent, "MobileAmpelExtrasPhaseEvent");

function MobileAmpelExtrasPhaseEvent:emptyNew()
    local self = Event:new(MobileAmpelExtrasPhaseEvent_mt);
    self.className="MobileAmpelExtrasPhaseEvent";
    return self;
end;

function MobileAmpelExtrasPhaseEvent:new(object, state)
    local self = MobileAmpelExtrasPhaseEvent:emptyNew()
	self.object = object;
    self.state = state;
	return self;
end;

function MobileAmpelExtrasPhaseEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
    self.state = streamReadInt32(streamId);
    self:run(connection);
end;

function MobileAmpelExtrasPhaseEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt32(streamId, self.state);
end;

function MobileAmpelExtrasPhaseEvent:run(connection)
	self.object.trafficIndex = self.state;
    if not connection:getIsServer() then
        g_server:broadcastEvent(MobileAmpelExtrasPhaseEvent:new(self.object, self.state), nil, connection, self.object);
    end;	
end;

function MobileAmpelExtrasPhaseEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MobileAmpelExtrasPhaseEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MobileAmpelExtrasPhaseEvent:new(vehicle, state));
		end;
	end;
end;